@ECHO OFF

ECHO *** HTML5 ***

SET PLATFORM=HTML5
SET GCC_PREFIX=call call-emscripten-

REM EM++ Options:
REM https://kripken.github.io/emscripten-site/docs/tools_reference/emcc.html

rem Debugging:
rem -g2 --llvm-lto 0 -s OUTLINING_LIMIT=99999 -s LEGACY_GL_EMULATION=1 -s ASSERTIONS=1

rem Release: -s ASSERTIONS=1 -g0
rem -O3 --llvm-lto 0 -s ASM_JS=1 -s OUTLINING_LIMIT=99999 -s LEGACY_GL_EMULATION=1
rem -s ASM_JS=1 --llvm-opts 3 --js-opts 1 --closure 1 -O1 --llvm-lto 0 
SET EMARGS=-g0 -O1 --llvm-opts 3 --js-opts 1 --closure 1 -s OUTLINING_LIMIT=99999 -s LEGACY_GL_EMULATION=1
SET GCC_ARGS=-DEMSCRIPTEN -DLINUX -DPOSIX -DUNIX -DWANT_SDL -DWANT_SDL_MIXER -DHAVE_OPENGL %EMARGS%
SET SPECIAL_CPP=
SET SPECIAL_O=
SET GLB_CORE=
SET GLB_GFX_CORE=OPENGL
SET LIB_POSTFIX=-WebGL

REM --- libCxImage ---
CALL "%~dp0..\..\Source\_build_lib_cximage.bat"

REM --- WebGL ---
CALL "%~dp0..\..\Source\_build_lib_glbasic.bat"

REM --- Trenki3D ---
SET GCC_ARGS=-DEMSCRIPTEN -DLINUX -DPOSIX -DUNIX -DWANT_SDL -DWANT_SDL_MIXER -DTRENKI3D %EMARGS%
SET GLB_GFX_CORE=TRENKI3D
SET LIB_POSTFIX=-Trenki3D
CALL "%~dp0..\..\Source\_build_lib_glbasic.bat"

IF "%NOPAUSE%"=="" PAUSE

