
//"use strict";

var LibraryGLB = {
  $GLB__deps: ['$Browser'],
  $GLB : {

		accX : 0.0,
		accY : 0.0,
		accZ : 0.0,

		cb_lastPoints : null, // mouse touch positions [.x,.y,b1,.id]
		cb_canvas : null,

		// remember touch positions for C call
		setCoords:function (e, idn) {
			var i = 0;
			if(e.identifier)
				i=e.identifier;
				
			var p = null;
			if (e.offsetX) {
				// Works in Chrome / Safari (except on iPad/iPhone)
				p= { id: i, x: e.offsetX, y: e.offsetY, b1: idn };
			}
			else {
				// Works in Safari on iPad/iPhone and Firefox 23+
				p= { id:i, x: e.pageX - cb_canvas.offsetLeft, y: e.pageY - cb_canvas.offsetTop, b1: idn };
			}
			
			for(var j=0; j<GLB.cb_lastPoints.length; ++j)
			{
				if(GLB.cb_lastPoints[j].id == i)
				{
					if(idn>0)
					{
						GLB.cb_lastPoints[j] = p;
						return;
					}
					else
					{
						GLB.cb_lastPoints.splice(j, 1);
						return;
					}
				}
			}
			if(idn>0)
			{
				GLB.cb_lastPoints.push(p);
			}
		},


		glb_start_touch:function (e) {
			if (e.touches) {
				// Touch event
				for (var i = 1; i <= e.touches.length; i++) {
					GLB.setCoords(e.touches[i - 1], 1); // Get info for finger #1
				}
			}
			else {
				// Mouse event
				GLB.setCoords(e, 1);
				cb_canvas.onmousemove = GLB.glb_move_touch;
			}
			return false;
		},

		// Called whenever cursor position changes after drawing has started
		glb_stop_touch:function (e) {
			e.preventDefault();
			// iOS sends the old touches here, and e.touches is empty
			if(e.changedTouches)
			{
				for (var i = 1; i <= e.changedTouches.length; i++) {
					GLB.setCoords(e.changedTouches[i - 1], 0);
				}
			}
			else if (e.touches) {
				// Touch event
				for (var i = 1; i <= e.touches.length; i++) {
					GLB.setCoords(e.touches[i - 1], 0);
				}
			}
			else {
				// Mouse event
				GLB.setCoords(e, 0);
				cb_canvas.onmousemove = null;
			}
		},

		glb_move_touch:function (e) {
			e.preventDefault(); // will think it's a scroll otherwise
			if (e.touches) {
				// Touch Enabled
				for (var i = 0; i < e.touches.length; i++) {
					GLB.setCoords(e.touches[i], 1); // Get info for finger i
				}
			}
			else {
				// Not touch enabled
				GLB.setCoords(e, 1);
			}
			return false;
		},

	}, // $GLB

	// Setup event handlers
	glb_init_multitouch:function () {
		cb_canvas = document.getElementById("canvas");

		GLB.cb_lastPoints = Array();

		if (cb_canvas.getContext) {
			cb_canvas.onmousedown  = GLB.glb_start_touch;
			cb_canvas.onmouseup    = GLB.glb_stop_touch;
			cb_canvas.ontouchstart = GLB.glb_start_touch;
			cb_canvas.ontouchmove  = GLB.glb_move_touch;
			cb_canvas.ontouchend   = GLB.glb_stop_touch;
			cb_canvas.ontouchcancel= GLB.glb_stop_touch;
			cb_canvas.onleave      = GLB.glb_stop_touch;
			// cb_canvas.ontouchstop  = GLB.glb_stop_touch; // does not exist?
		}

		// also init tilt support
		window.ondevicemotion = function(event) {
			GLB.accX = event.accelerationIncludingGravity.x;  
			GLB.accY = event.accelerationIncludingGravity.y;  
			GLB.accZ = event.accelerationIncludingGravity.z;  
		}
		// write to int32 ptr array
		// {{{ makeSetValue('outPtr', 'index*4', 'js_var', 'i32') }}}
	},

	// int32 ptr to struct x,y,b1
	glb_get_multitouch_info:function (imouse, int_ptr)
	{
		if(imouse<GLB.cb_lastPoints.length)
		{
			var p = GLB.cb_lastPoints[imouse];
			{{{ makeSetValue('int_ptr', '0', 'p.x',  'i32') }}}
			{{{ makeSetValue('int_ptr', '4', 'p.y',  'i32') }}}
			{{{ makeSetValue('int_ptr', '8', 'p.b1', 'i32') }}}
		}
		return GLB.cb_lastPoints.length;
	},
	
	glb_get_gravity:function( float_ptr )
	{
		{{{ makeSetValue('float_ptr', '0', 'GLB.accX',  'float') }}}
		{{{ makeSetValue('float_ptr', '4', 'GLB.accY',  'float') }}}
		{{{ makeSetValue('float_ptr', '8', 'GLB.accZ',  'float') }}}
		return (window.DeviceOrientationEvent) ? 1: 0;
	},


	end_of_struct:0
};

autoAddDeps(LibraryGLB, '$GLB');
mergeInto(LibraryManager.library, LibraryGLB);



